// -*- c++ -*-

/*
 * Jakelib2 - General purpose C++ library
 * Copyright (C) 2001 Florian Wolff  (florian@donuz.de)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * $Id: FileOutputStream.h,v 1.22 2003/09/12 16:13:51 florian Exp $
 */

#ifndef INCLUDE_JAKELIB2_IO_FILEOUTPUTSTREAM_H
# define INCLUDE_JAKELIB2_IO_FILEOUTPUTSTREAM_H
# include "OutputStream.h"

# if defined(JAKELIB_WIN32API)
#  include <windows.h>
# endif

namespace jakelib {
  namespace io {
    class File;

    /**
     * This classes allows a stream of data to be written to a disk file.
     *
     * @class FileOutputStream
     * @version $Id: FileOutputStream.h,v 1.22 2003/09/12 16:13:51 florian Exp $
     * @author Florian 'Overflo' Wolff (florian@donuz.de)
     */
    class FileOutputStream : public OutputStream
    {
    public:

      FileOutputStream(File* file, jboolean append = false);
      FileOutputStream(char* filename, jboolean append = false); 
      FileOutputStream(jakelib::lang::String* filename, jboolean append = false); 

      ~FileOutputStream(); 
      void write(int b);
      void write(jbyte* b, int offset, int len);
      void close();
  
    protected:

      jboolean append;

#if defined(JAKELIB_WIN32API)
      HANDLE handle;
#else
      int handle;
#endif

      void init(jakelib::lang::String* filename);

      JAKELIB_DECLARE_CLASS(FileOutputStream);
    };

  }
}
#endif

