// -*- c++ -*-

/*
 * Jakelib2 - General purpose C++ library
 * Copyright (C) 2001 Florian Wolff  (florian@donuz.de)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * $Id: Serializable.h,v 1.8 2003/09/13 08:46:07 florian Exp $
 */


#ifndef INCLUDE_JAKELIB2_IO_SERIALIZABLE_H
# define INCLUDE_JAKELIB2_IO_SERIALIZABLE_H

namespace jakelib {

  namespace lang {
    class Object;
    }

  namespace io {

    /**
     * \c Attention! Nothing concerning serialization has been implemented yet!
     *
     * This interface has no methods. It simply serves to indicate that
     * the implementing class may be serialized.
     *
     * @author Aaron M. Renn (arenn@urbanophile.com)
     * @author Warren Levy <warrenl@cygnus.com>
     * @author Alex Fabijanic <fabijanica@nucorsteel.com>(jakelib2 port)
     */
    class Serializable : public jakelib::lang::Interface
    {

      JAKELIB_DECLARE_INTERFACE(Serializable);
    }; // class Serializable

  }
}

#endif
