// -*- c++ -*-

/*
 * Jakelib2 - General purpose C++ library
 * Copyright (C) 2001 Florian Wolff  (florian@donuz.de)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * $Id: StandardOutputStream.h,v 1.18 2003/09/13 08:46:07 florian Exp $
 */

#ifndef INCLUDE_JAKELIB2_IO_STANDARDOUTPUTSTREAM_H
# define INCLUDE_JAKELIB2_IO_STANDARDOUTPUTSTREAM_H
#include "OutputStream.h"

namespace jakelib {
  namespace io {

    /**
     * StandardOutputStream encapsulates the system's stdout and stderr streams.
     *
     * @class StandardOutputStream
     * @version $Id: StandardOutputStream.h,v 1.18 2003/09/13 08:46:07 florian Exp $
     * @author Florian 'Overflo' Wolff (florian@donuz.de)
     */
    class StandardOutputStream : public OutputStream
    {
    public:

      /**
       * System-dependend constructor.
       */
      StandardOutputStream(FILE* fd);

      ~StandardOutputStream(); 

      void write(int b);

      void write(jbyte* b, int offset, int len);

      void close();

    protected:

      FILE* fd;

      JAKELIB_DECLARE_CLASS(StandardOutputStream);
    };

  }
}
#endif

