// -*- c++ -*-

/*
 * Jakelib2 - General purpose C++ library
 * Copyright (C) 2001 Florian Wolff  (florian@donuz.de)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * $Id: Syslog.h,v 1.14 2003/09/13 08:46:07 florian Exp $
 */

#ifndef INCLUDE_JAKELIB2_IO_SYSLOG_H
# define INCLUDE_JAKELIB2_IO_SYSLOG_H
# include "PrintWriter.h"

namespace jakelib {
  namespace io {

    /**
     * Just a simple sys-logging facility.
     *
     * @class Syslog
     * @version $Id: Syslog.h,v 1.14 2003/09/13 08:46:07 florian Exp $
     * @author Florian 'Overflo' Wolff (florian@donuz.de)
     */
    class Syslog : public jakelib::lang::Object
    {
    public:

      Syslog(jakelib::lang::String* filename);

      ~Syslog();

      void println();

      void print(char* str);

      void print(jakelib::lang::String* str);

      void print(jakelib::lang::String& str);

      void println(jakelib::lang::String* str);

      void print(jchar c);

      void println(jchar c);
  
    protected:

      OutputStream* outputStream;

      PrintWriter* out;

      jakelib::lang::String* filename;

      JAKELIB_DECLARE_CLASS(Syslog);
    };
  }
}
#endif

