/*
 * Jakelib2 - General purpose C++ library
 * Copyright (C) 2001 Florian Wolff  (florian@donuz.de)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * $Id: Comparable.h,v 1.4 2003/01/25 16:16:23 florian Exp $
 */

#ifndef INCLUDE_JAKELIB2_LANG_COMPARABLE_H
# define INCLUDE_JAKELIB2_LANG_COMPARABLE_H

namespace jakelib {
  namespace lang {

    /**
     * @class Comparable
     * @version $Id: Comparable.h,v 1.4 2003/01/25 16:16:23 florian Exp $
     * @author Florian 'Overflo' Wolff (florian@donuz.de)
     */
    class Comparable : public Interface
      {
      public:
	virtual int compareTo(Object* obj) = 0;

        JAKELIB_DECLARE_INTERFACE(Comparable);
      };
  }
}
#endif

