// -*- c++ -*-

/*
 * Jakelib2 - General purpose C++ library
 * Copyright (C) 2001 Florian Wolff  (florian@donuz.de)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * $Id: Interface.h,v 1.5 2003/09/13 08:46:07 florian Exp $
 */

#ifndef INCLUDE_JAKELIB2_LANG_INTERFACE_H
# define INCLUDE_JAKELIB2_LANG_INTERFACE_H

namespace jakelib {
  namespace lang {

    /**
     * @brief \c Interface is the base class for all interfaces
     * throughout jakelib.
     *
     * @class Interface
     * @version $Id: Interface.h,v 1.5 2003/09/13 08:46:07 florian Exp $
     * @author Florian 'Overflo' Wolff (florian@donuz.de)
     */
    class Interface
      {
      public:

	/**
	 * @brief Returns the corresponding \c Class object.
	 */
        virtual jakelib::lang::Class* getClass() = 0;

	/**
	 * @brief Determines whether this object is an instance of the class
	 * specified by a fully qualified class name like
	 * "\c jakelib.lang.Object".
	 */
	virtual jboolean instanceOf(char* name) { return false;};

	/**
	 * @brief Determines whether this object is an instance of the class
	 * specified by a fully qualified class name like
	 * "\c jakelib.lang.Object".
	 */
	virtual jboolean instanceOf(String* name) { return false;};
      };
  }
}

#endif

