// -*- c++ -*-

/*
 * Jakelib2 - General purpose C++ library
 * Copyright (C) 2001 Florian Wolff  (florian@donuz.de)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * $Id: SocketInputStream.h,v 1.20 2003/09/13 08:49:54 florian Exp $
 */

#ifndef INCLUDE_JAKELIB2_NET_SOCKETINPUTSTREAM_H
# define INCLUDE_JAKELIB2_NET_SOCKETINPUTSTREAM_H
# include "../io/InputStream.h"

namespace jakelib {
  namespace net {

    /**
     * An input stream for TCP sockets.
     *
     * @class SocketInputStream
     * @version $Id: SocketInputStream.h,v 1.20 2003/09/13 08:49:54 florian Exp $
     * @author Florian 'Overflo' Wolff (florian@donuz.de)
     */
    class SocketInputStream : public jakelib::io::InputStream
      {
      public:

        /**
         * System-dependend constructor.
         */
	SocketInputStream(JL2_SOCKET sock); 

	~SocketInputStream();

	int read();

	int read(jbyte* b, int offset, int len);

	void close();

	void reset();

	void setContentLength(int length);

	void setBlocking(jboolean on);
  
      protected:

	JL2_SOCKET sock;

	int contentLength;

	JAKELIB_DECLARE_CLASS(SocketInputStream);
      };

  }
}
#endif

