/*
 * Jakelib2 - General purpose C++ library
 * Copyright (C) 2001 Florian Wolff  (florian@donuz.de)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * $Id: CharToByteConverter.h,v 1.11 2003/01/11 14:05:31 florian Exp $
 */

#ifndef INCLUDE_JAKELIB2_TEXT_ENC_CHARTOBYTECONVERTER_H
# define INCLUDE_JAKELIB2_TEXT_ENC_CHARTOBYTECONVERTER_H

namespace jakelib {
  namespace util {
    class ByteArray;
    class Hashtable;
  }

  namespace text {
    namespace enc {


      /**
       * @brief
       *
       * @class CharToByteConverter
       * @version $Id: CharToByteConverter.h,v 1.11 2003/01/11 14:05:31 florian Exp $
       * @author Florian 'Overflo' Wolff (florian@donuz.de)
       */
      class CharToByteConverter : public jakelib::lang::Object
	{
	public:
	  CharToByteConverter(char* characterEncoding);

	  virtual jakelib::lang::String* getCharacterEncoding();
	  jakelib::lang::String* toString();

	  virtual void convert(jchar* input, int inOff, int inEnd,
			       jakelib::util::ByteArray* output) = 0;

	  static CharToByteConverter* getDefault();
	  static CharToByteConverter* getConverter(jakelib::lang::String* encoding);
	  static CharToByteConverter* getConverter(char* encoding);

          /**
           * @brief Called by \c Object::initJakelib2().
           * Do not use otherwise.
           */
	  static void initConverters();

	protected:

	  jboolean substitutionMode;

	private:
	  static jakelib::util::Hashtable* converters;
	  static CharToByteConverter* defaultConverter;
	  
	  jakelib::lang::String* characterEncoding;

	  JAKELIB_DECLARE_CLASS(CharToByteConverter);
	};
    }
  }
}

#endif
