/*
 * Jakelib2 - General purpose C++ library
 * Copyright (C) 2001 Florian Wolff  (florian@donuz.de)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * $Id: CharToByteSingleByte.h,v 1.11 2003/01/11 14:05:31 florian Exp $
 */

#ifndef INCLUDE_JAKELIB2_TEXT_ENC_CHARTOBYTESINGLEBYTE_H
# define INCLUDE_JAKELIB2_TEXT_ENC_CHARTOBYTESINGLEBYTE_H
#include "CharToByteConverter.h"

namespace jakelib {
  namespace util {
    class ByteArray;
  }
  namespace text {
    namespace enc {


      /**
       * @brief
       *
       * @class CharToByteSingleByte
       * @version $Id: CharToByteSingleByte.h,v 1.11 2003/01/11 14:05:31 florian Exp $
       * @author Florian 'Overflo' Wolff (florian@donuz.de)
       */
      class CharToByteSingleByte : public CharToByteConverter
	{
	public:
	  CharToByteSingleByte(char* characterEncoding,
			       const unsigned char* conversionTable, int lastMappable);

	  void convert(jchar* input, int inOff, int inEnd,
		       jakelib::util::ByteArray* output);

	protected:

	  const unsigned char* conversionTable;

	  int lastMappable;

	  jbyte getConversion(jchar c);

	  JAKELIB_DECLARE_CLASS(CharToByteSingleByte);
	};
    }
  }
}

#endif
