/*
 * Jakelib2 - General purpose C++ library
 * Copyright (C) 2001 Florian Wolff  (florian@donuz.de)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * $Id: EventListener.h,v 1.2 2002/08/13 13:01:36 florian Exp $
 */

#ifndef INCLUDE_JAKELIB2_UTIL_EVENTLISTENER_H
# define INCLUDE_JAKELIB2_UTIL_EVENTLISTENER_H

namespace jakelib {
  namespace util {

    /**
     * @brief Empty interface that is implemented by classes that need to receive
     * events.
     *
     * Subinterfaces define methods that can be called to fire an
     * event notification. Normally the name of these subinterfaces end in
     * \c Listener and all method described by the subinterface
     * take as argument a subclass of \c EventObject.
     *
     * @class EventListener
     * @version $Id: EventListener.h,v 1.2 2002/08/13 13:01:36 florian Exp $
     * @author Florian 'Overflo' Wolff (florian@donuz.de)
     */
    class EventListener{};
  }
}

#endif

