/*
 * Jakelib2 - General purpose C++ library
 * Copyright (C) 2001 Florian Wolff  (florian@donuz.de)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * $Id: HashtableIterator.h,v 1.14 2002/09/15 08:23:28 florian Exp $
 */

#ifndef INCLUDE_JAKELIB2_UTIL_HASHTABLEITERATOR_H
# define INCLUDE_JAKELIB2_UTIL_HASHTABLEITERATOR_H
# include "Iterator.h"

namespace jakelib {
  namespace util {

    class Hashtable;

    /**
     * @class HashtableIterator
     * @version $Id: HashtableIterator.h,v 1.14 2002/09/15 08:23:28 florian Exp $
     * @author Florian 'Overflo' Wolff (florian@donuz.de)
     */
    class HashtableIterator : public jakelib::lang::Object, Iterator
      {
      public:
	HashtableIterator(Hashtable* hash);

	jboolean hasNext();
	jakelib::lang::Object* next();
	void remove();
  
      protected:
	int index;
	Hashtable* hash;

	JAKELIB_DECLARE_CLASS(HashtableIterator);
      };

  }
}
#endif

