/*
 * Jakelib2 - General purpose C++ library
 * Copyright (C) 2001 Florian Wolff  (florian@donuz.de)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * $Id: StringComparator.h,v 1.9 2003/01/25 15:56:00 florian Exp $
 */

#ifndef INCLUDE_JAKELIB2_UTIL_STRINGCOMPARATOR_H
# define INCLUDE_JAKELIB2_UTIL_STRINGCOMPARATOR_H
# include "Comparator.h"

namespace jakelib {
  namespace util {

    /**
     * @class StringComparator
     * @version $Id: StringComparator.h,v 1.9 2003/01/25 15:56:00 florian Exp $
     * @author Florian 'Overflo' Wolff (florian@donuz.de)
     */
    class StringComparator : public jakelib::lang::Object, public Comparator
      {
      public:
	/**
	 * Compares two objects. Returns <TT>0</TT> if
	 * the objects are equal, <TT>1</TT> if object <TT>a</TT> is greater than <TT>b</TT> and
	 * <TT>-1</TT> if object <TT>a</TT> is less than <TT>b</TT>.
	 */
	int compare(jakelib::lang::Object* a, jakelib::lang::Object* b);

        JAKELIB_DECLARE_CLASS(StringComparator);
      };

  }
}


#endif

