// -*- c++ -*-

/*
 * jakelib2-regex - Regular Expressions for Jakelib2
 * Copyright (C) 2003 Florian Wolff  (florian@donuz.de)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * $Id: PatternSyntaxException.h,v 1.1 2003/09/24 17:14:54 florian Exp $
 */

#ifndef INCLUDE_JAKELIB2_UTIL_REGEX_PATTERNSYNTAXEXCEPTION_H
# define INCLUDE_JAKELIB2_UTIL_REGEX_PATTERNSYNTAXEXCEPTION_H

namespace jakelib {
  namespace util {
    namespace regex {
      
      /**
       *
       * @class PatternSyntaxException
       * @version $Id: PatternSyntaxException.h,v 1.1 2003/09/24 17:14:54 florian Exp $
       * @author Florian 'Overflo' Wolff (florian@donuz.de)
       */
      class PatternSyntaxException : public jakelib::lang::IllegalArgumentException
      {
      public:
        PatternSyntaxException(jakelib::lang::String* msg);

        JAKELIB_DECLARE_CLASS(PatternSyntaxException);
      };

    }
  }
}

#endif

